﻿using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace Application2
{
    class Helper
    {
        public static Vector3 MouseToLogicalCoords(System.Drawing.Point location,
            System.Drawing.Size clientSize)
        {
            Vector3 v;

            v.X = (float)location.X / (float)Math.Max(clientSize.Width - 1, 1) * 2.0f - 1.0f;
            v.Y = 1.0f - (float)location.Y / (float)Math.Max(clientSize.Height - 1, 1) * 2.0f;
            v.Z = 0.0f;

            return v;
        }

        public static Viewport SquareViewport(System.Drawing.Size clientSize)
        {
            Viewport viewport = new Viewport();

            viewport.Width = Math.Min(clientSize.Width, clientSize.Height);
            viewport.Height = viewport.Width;
            viewport.X = (clientSize.Width- viewport.Width) / 2;
            viewport.Y = (clientSize.Height - viewport.Height) / 2;
            
            return viewport;
        }

        public static Viewport FullScreenViewport(System.Drawing.Size clientSize)
        {
            Viewport viewport = new Viewport();
            viewport.Width = clientSize.Width;
            viewport.Height = clientSize.Height;
            return viewport;
        }

        public static Viewport SquareViewport(PresentationParameters presentParams)
        {
            return SquareViewport(new System.Drawing.Size(presentParams.BackBufferWidth, 
                presentParams.BackBufferHeight));
        }

        public static Viewport FullScreenViewport(PresentationParameters presentParams)
        {
            return FullScreenViewport(new System.Drawing.Size(presentParams.BackBufferWidth,
                presentParams.BackBufferHeight));
        }
    }
}
